unit VolumeForm;
{$ifdef FPC}{$mode objfpc}{$h+}{$endif}
interface
uses
 mclasses,msetypes,mseglob,mseguiglob,mseguiintf,mseapplication,msestat,
 msegui,msegraphics,msegraphutils,mseevent,mseclasses,msewidgets,
 mseforms,msesimplewidgets,msegraphedits;

type

 { TfrmVolume }

 TfrmVolume = class(tmseform)
   sdVolume: tslider;
   cbMute: tbooleanedit;
   lblVolume: tlabel;
   procedure applicationev(const sender: tactcomponent; var aevent: tmseevent;
     var handled: Boolean);
   procedure ArrangeWidgets(const Sender: TObject);   
   procedure MyExit(const sender: TObject);
   procedure MyDeactivate(const sender: TObject);
 private
   FOnMute: notifyeventty;
   FOnVolume: notifyeventty;
   procedure AppActiveChanged(const avalue: boolean);
   function GetMuted: Boolean;
   function GetVolume: Byte;
   procedure InternalMuteChanged(const sender: tobject);
   procedure InternalVolumeChanged(const sender: tobject; var avalue: realty;
     var accept: boolean);
   procedure SetMuted(AValue: Boolean);
   procedure SetVolume(AValue: Byte);
 public
   constructor create(const atransientfor: twidget); reintroduce;
   destructor destroy; override;
 published
   property Volume: Byte read GetVolume write SetVolume;
   property Muted: Boolean read GetMuted write SetMuted;
   property OnVolume: notifyeventty read FOnVolume write FOnVolume;
   property OnMute: notifyeventty read FOnMute write FOnMute;
 end;

implementation

uses
 volumeform_mfm, math, sysutils;

{ TfrmVolume }

procedure TfrmVolume.applicationev(const sender: tactcomponent;
  var aevent: tmseevent; var handled: Boolean);
begin
  writeln('Event ', aevent.kind);
  if (aevent.kind = ek_buttonpress) then begin
   with tmouseevent(aevent) do begin
    if (fwinid <> window.winid) or //click in other window
                            not pointinrect(fpos,widgetsizerect) then begin
                                   //click out of window in case of modal
     writeln('Release volume');
     release();
    end;
   end;
  end;
end;

procedure TfrmVolume.ArrangeWidgets(const Sender: TObject);
begin
  with container.frame do begin
    lblVolume.pos := makepoint(framei_left,framei_top);
    cbMute.pos := makepoint((Self.clientwidth div 2)-(cbMute.width div 2),
      Self.clientheight-framei_bottom-cbMute.widgetsizerect.cy);
    sdVolume.widgetrect := mr((Self.clientwidth div 2)-(sdVolume.width div 2),lblVolume.bottom,
      sdVolume.width,cbMute.pos.y-lblVolume.bottom);
  end;

  //WriteLn(cbMute.widgetsizerect.cy);
  //writeln('paintrect = ',paintrect.y,'|',paintrect.size.cy);
  //writeln('paintclientrect = ',paintclientrect.cy,'|',paintclientrect.size.cy);
  //writeln('paintheight = ',paintheight);
  //writeln('clippedpaintrect = ',clippedpaintrect.cy,'|',clippedpaintrect.size.cy);
  //writeln('innerpaintrect = ',innerpaintrect.y,'|',innerpaintrect.size.cy);
  //writeln('widgetsizerect = ',widgetsizerect.cy,'|',widgetsizerect.size.cy);
  //writeln('paintsizerect = ',paintsizerect.cy,'|',paintsizerect.size.cy);
  //writeln('clientsizerect = ',clientsizerect.cy,'|',clientsizerect.size.cy);
  //writeln('containerclientsizerect = ',containerclientsizerect.cy,'|',containerclientsizerect.size.cy);
  //writeln('clientrect = ',clientrect.pos.y,'|',clientrect.size.cy);
  //writeln('clientsize = ',clientsize.cy,'|',clientsize.cy);
  //writeln('clientheight = ',clientheight,'|',clientheight);
  //writeln('clientwidgetrect = ',clientwidgetrect.cy,'|',clientwidgetrect.size.cy);
  //writeln('innerwidgetrect = ',innerwidgetrect.pos.y,'|',innerwidgetrect.size.cy);
  //writeln('innerclientrect = ',innerclientrect.cy,'|',innerclientrect.size.cy);
  //writeln('innerclientsize = ',innerclientsize.cy,'|',innerclientsize.cy);
end;

procedure TfrmVolume.AppActiveChanged(const avalue: boolean);
begin
  visible := avalue;
  writeln('Active ', avalue);
end;

function TfrmVolume.GetMuted: Boolean;
begin
  Result := cbMute.value;
end;

function TfrmVolume.GetVolume: Byte;
begin
  Result := round(sdVolume.value*100);
end;

procedure TfrmVolume.InternalMuteChanged(const sender: tobject);
begin
  if FOnMute<>nil then
    FOnMute(Self);
end;

procedure TfrmVolume.InternalVolumeChanged(const sender: tobject;
  var avalue: realty; var accept: boolean);
begin
  lblVolume.caption := IntToStr(round(avalue*100))+'%';
  if FOnVolume<>nil then
    FOnVolume(Self);
end;

procedure TfrmVolume.SetMuted(AValue: Boolean);
begin
  cbMute.value := AValue;
end;

procedure TfrmVolume.SetVolume(AValue: Byte);
begin
  sdVolume.value := Min(100, AValue) / 100;
  lblVolume.caption := IntToStr(round(sdVolume.value*100))+'%';
end;

constructor TfrmVolume.create(const atransientfor: twidget);
begin
  inherited create(nil);
  width := 80;
  sdVolume.onsetvalue := @InternalVolumeChanged;
  cbMute.onchange := @InternalMuteChanged;
  application.registeronapplicationactivechanged(@AppActiveChanged);
  show(ml_none,atransientfor);
end;

destructor TfrmVolume.destroy;
begin
  writeln('killing volume');
  application.unregisteronapplicationactivechanged(@AppActiveChanged);
  inherited destroy;
end;

procedure TfrmVolume.MyExit(const sender: TObject);
begin
  writeln('exit');
end;

procedure TfrmVolume.MyDeactivate(const sender: TObject);
begin
  writeln('deactivate');
end;

end.
